///chunk_model_block(model, x, y, z, west z, north z)
/*
    Uses model primitives to model a block at a position.
    We only handle the top, north face, and west face.
    
    Argument0   -   model to add to
    Argument1   -   x-pos of block
    Argument2   -   y-pos of block
    Argument3   -   z-pos of block
    Argument4   -   z-pos of block to the west
    Argument5   -   z-pos of block to the north
 */
 
var __model = argument0,
    __color = c_green,
    __s = BLOCK.size,
    __x = argument1 * BLOCK.size,
    __y = argument2 * BLOCK.size,
    __z = argument3 * BLOCK.size,
    __wz = argument4 * BLOCK.size,
    __nz = argument5 * BLOCK.size;
var __water = CHUNK.maxHeight / 100 * CHUNK.waterLevel;
if (argument3 <= __water)
    __color = c_blue;
else
    __color = make_color_rgb(255 / (CHUNK.maxHeight - __water) * (argument3 - __water),
                             128 + 127 / (CHUNK.maxHeight - __water) * (argument3 - __water),
                             255 / (CHUNK.maxHeight - __water) * (argument3 - __water));

// -- NOTE -- // Define CLOCKWISE if picturing from front

//Top of block:
d3d_model_vertex_normal_colour(__model, __x + __s, __y + __s, __z, 0, 0, 1, __color, 1);
d3d_model_vertex_normal_colour(__model, __x, __y + __s, __z, 0, 0, 1, __color, 1);
d3d_model_vertex_normal_colour(__model, __x, __y, __z, 0, 0, 1, __color, 1);

d3d_model_vertex_normal_colour(__model, __x, __y, __z, 0, 0, 1, __color, 1);
d3d_model_vertex_normal_colour(__model, __x + __s, __y, __z, 0, 0, 1, __color, 1);
d3d_model_vertex_normal_colour(__model, __x + __s, __y + __s, __z, 0, 0, 1, __color, 1);

// North side of block:
if (__nz != __z && argument5 != -1)
{
    d3d_model_vertex_normal_colour(__model, __x + __s, __y, __z, 0, -1, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x, __y, __z, 0, -1, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x + __s, __y, __nz, 0, -1, 0, __color, 1);

    
    d3d_model_vertex_normal_colour(__model, __x, __y, __z, 0, -1, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x, __y, __nz, 0, -1, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x + __s, __y, __nz, 0, -1, 0, __color, 1);

    
}

// West side of block:
if (__wz != __z && argument4 != -1)
{
    d3d_model_vertex_normal_colour(__model, __x, __y, __z, 1, 0, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x, __y + __s, __z, 1, 0, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x, __y + __s, __wz, 1, 0, 0, __color, 1);
    
    d3d_model_vertex_normal_colour(__model, __x, __y, __z, 1, 0, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x, __y + __s, __wz, 1, 0, 0, __color, 1);
    d3d_model_vertex_normal_colour(__model, __x, __y, __wz, 1, 0, 0, __color, 1);
}