///chunk_model_generate(id)
/*
    Generates the 3D terran model for this chunk.
    
    Argument0   -   the chunk id
 */
//USEFUL: http://www.gamedev.net/topic/612655-3d-perlin-noise-map-ridges/ 
//http://www.gamedev.net/blog/33/entry-2227887-more-on-minecraft-type-world-gen/
 
//Clear any previous models
if (argument0._model != null)
    d3d_model_destroy(_model);

//Create a new model for the chunk:
argument0._model = d3d_model_create()
var __model = argument0._model, // Makes for easier use in the script
    __x = argument0.x * CHUNK.size,
    __y = argument0.y * CHUNK.size;

d3d_model_primitive_begin(__model, pr_trianglelist);

var __westz,
    __northz = -1;
    
var __freq = 0.3,
    __scale = 0.0075;
    //Good base: 8, 0.2, 0.005
    
for (var i = CHUNK.size - 1; i >= 0; --i)
        __westz[i] = floor(simplex_octave2(__x - 1, __y + i, graphicControllerObj._hash, graphicControllerObj._grad,
                                        CHUNK.minHeight, CHUNK.maxHeight, 8, __freq, __scale));
for (var i = 0; i < CHUNK.size; ++i)
{
    // -- STUB -- // Won't work when things get more complex:
    __northz = floor(simplex_octave2(__x + i, __y - 1, graphicControllerObj._hash, graphicControllerObj._grad,
                                        CHUNK.minHeight, CHUNK.maxHeight, 8, __freq, __scale));
    for (var j = 0; j < CHUNK.size; ++j)
    {

        //Generate the normal heightmap:
        var __h = simplex_octave2(__x + i, __y + j, graphicControllerObj._hash, graphicControllerObj._grad,
                                  CHUNK.minHeight, CHUNK.maxHeight, 8, __freq, __scale);
                                        

        chunk_model_block(__model, i, j, floor(__h), __westz[j], __northz);
        
        //Currently storing z value. When 3D, use array of 3D values
        with (argument0)
            _grid[@i, j] = floor(__h);

        __northz = floor(__h);
        __westz[j] = floor(__h);
    }
}
d3d_model_primitive_end(__model);